diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/eh/cond2.C gcc-3.3.3/gcc/testsuite/g++.dg/eh/cond2.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/eh/cond2.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/eh/cond2.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,19 @@
+// PR c++/14083
+
+struct A { 
+  A() throw() { } 
+  A(const A&) throw() { } 
+}; 
+ 
+struct X { 
+  A a; 
+  X(); 
+  X& operator=(const X& __str); 
+}; 
+ 
+bool operator==(const X& __lhs, const char* __rhs); 
+        
+int main() { 
+  X x; 
+  x=="" ? x : throw 1; 
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/eh/spec7.C gcc-3.3.3/gcc/testsuite/g++.dg/eh/spec7.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/eh/spec7.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/eh/spec7.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,35 @@
+// PR 14535
+// { dg-do run }
+// { dg-options "-O -finline" }
+//
+// Original test case failure required that Raiser constructor be inlined.
+
+extern "C" void abort(); 
+bool destructor_called = false; 
+ 
+struct B { 
+    virtual void Run(){}; 
+}; 
+ 
+struct D : public B { 
+    virtual void Run() 
+      { 
+        struct O { 
+            ~O() { destructor_called = true; }; 
+        } o; 
+         
+        struct Raiser { 
+            Raiser()  throw( int ) {throw 1;}; 
+        } raiser; 
+      }; 
+}; 
+ 
+int main() { 
+    try { 
+      D d; 
+      static_cast<B&>(d).Run(); 
+    } catch (...) {} 
+ 
+    if (!destructor_called) 
+      abort (); 
+} 
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/ext/anon-struct4.C gcc-3.3.3/gcc/testsuite/g++.dg/ext/anon-struct4.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/ext/anon-struct4.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/ext/anon-struct4.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,3 @@
+// PR c++/14401
+
+struct { struct { int& i ; } bar ; } foo ; // { dg-error "" }
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/ctor3.C gcc-3.3.3/gcc/testsuite/g++.dg/init/ctor3.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/ctor3.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/init/ctor3.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,6 @@
+// PR c++/14401
+
+struct S {
+  S() {} // { dg-error "" }
+  const int i;
+};
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/ref11.C gcc-3.3.3/gcc/testsuite/g++.dg/init/ref11.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/ref11.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/init/ref11.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,13 @@
+// PR c++/14230
+
+struct A {
+  A ();
+  A (const A&);
+  A& operator= (const A&);
+};
+
+struct D {
+  A a;
+};
+
+const A& z = D().a;
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/static2.C gcc-3.3.3/gcc/testsuite/g++.dg/init/static2.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/static2.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/init/static2.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,25 @@
+// PR 14804
+// { dg-do run }
+
+struct A {
+  virtual void foo() = 0;
+};
+
+struct B : public A {
+  virtual void bar() = 0;
+};
+
+typedef void (A::*mfptr)();
+
+struct D {
+  mfptr p;
+};
+
+static const D ds[] = {
+  { reinterpret_cast<mfptr>(&B::bar) },
+};
+
+int main()
+{
+  return 0;
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/union1.C gcc-3.3.3/gcc/testsuite/g++.dg/init/union1.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/init/union1.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/init/union1.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,5 @@
+// PR c++/14401
+
+union U {
+  int& i; // { dg-error "" }
+};
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/lookup/enum2.C gcc-3.3.3/gcc/testsuite/g++.dg/lookup/enum2.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/lookup/enum2.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/lookup/enum2.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,5 @@
+// PR c++/14476
+
+struct tree_common {
+  enum tree_code code : 8;      // { dg-error "" }
+};
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/opt/inline4.C gcc-3.3.3/gcc/testsuite/g++.dg/opt/inline4.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/opt/inline4.C	2003-07-23 01:13:42.000000000 -0600
+++ gcc-3.3.3/gcc/testsuite/g++.dg/opt/inline4.C	2004-04-20 02:29:00.000000000 -0600
@@ -10,4 +10,4 @@
   g<1000>();
 }
 
-// { dg-final { scan-assembler-not "_Z1g"  } }
+// { dg-final { scan-assembler-not "\n_?_Z1gILi\[0-9\]+EEvv\[: \t\n\]"  } }
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/opt/inline6.C gcc-3.3.3/gcc/testsuite/g++.dg/opt/inline6.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/opt/inline6.C	2004-01-02 04:15:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/opt/inline6.C	2004-04-20 02:29:00.000000000 -0600
@@ -1,6 +1,6 @@
 // PR c++/13081
 // { dg-options "-O2" }
-// { dg-final { scan-assembler-not "foo" } }
+// { dg-final { scan-assembler-not "\n_?_Z3fooIlET_S0_\[: \t\n\]" } }
 
 template<typename T> T foo(T);
  
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/other/crash-2.C gcc-3.3.3/gcc/testsuite/g++.dg/other/crash-2.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/other/crash-2.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/other/crash-2.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,13 @@
+// { dg-do compile }
+// { dg-options "-finline -finline-functions" }
+// Contributed by Hans Buchmann <hans dot buchmann at fhso dot ch>
+// PR c++/14033: ICE while inlining a function with incomplete parameter
+
+struct A;           // { dg-error "forward declaration" }
+void foo(A a) {}    // { dg-error "incomplete" }
+struct A {};
+
+void bar(void)
+{
+ foo(A());
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/other/profile1.C gcc-3.3.3/gcc/testsuite/g++.dg/other/profile1.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/other/profile1.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/other/profile1.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,51 @@
+// PR 11767
+// { dg-do run }
+// { dg-options "-fnon-call-exceptions -fprofile-arcs" }
+
+#include <string>
+
+typedef unsigned long ACE_UINT32;
+extern "C" void abort();
+
+static ACE_UINT32 const msc_maxCurrencyID = 9999;
+
+class ResourceBalanceType2
+{
+  public:
+   explicit ResourceBalanceType2(
+      ACE_UINT32 resourceBalanceTypeID,
+      ACE_UINT32 isoValue,
+      const std::string& rc_shortName,
+      const std::string& rc_symbol
+    );
+  public:
+    const ACE_UINT32 mc_resBalTypeID;
+    const ACE_UINT32 mc_isoValue;
+    const std::string mc_shortName;
+    const std::string mc_symbol;
+};
+
+void f(){}
+
+ResourceBalanceType2::ResourceBalanceType2(
+    ACE_UINT32 resourceBalanceTypeID,
+    ACE_UINT32 isoValue,
+    const std::string& rc_shortName,
+    const std::string& rc_symbol)
+  : mc_resBalTypeID(resourceBalanceTypeID),
+    mc_isoValue(isoValue),
+    mc_shortName(rc_shortName),
+    mc_symbol(rc_symbol)
+{
+  bool isGreater = (mc_isoValue > msc_maxCurrencyID);
+  f();
+  bool temp = mc_isoValue > msc_maxCurrencyID;
+  if (!isGreater) abort();
+  if (!temp) abort();
+}
+
+int main (int argc, char * argv[])
+{
+  ACE_UINT32 const mc_isoValue = 10000;
+  ResourceBalanceType2 rbResourceBalanceType2(3, mc_isoValue, "ATM", "M");
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/other/switch1.C gcc-3.3.3/gcc/testsuite/g++.dg/other/switch1.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/other/switch1.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/other/switch1.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,20 @@
+// { dg-do compile }
+// Contributed by: Nick Savoiu <savoiu at ics dot uci dot edu>
+// PR c++/14250: Incomplete type in switch statement
+
+template <typename T> 
+struct A {
+  operator int();
+};
+ 
+struct C1 { 
+  static A<void> t1; 
+ 
+  void fun() 
+  { 
+   switch(t1) 
+   { 
+    default: break; 
+   } 
+  } 
+}; 
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/parse/init1.C gcc-3.3.3/gcc/testsuite/g++.dg/parse/init1.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/parse/init1.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/parse/init1.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,2 @@
+// { dg-do compile }
+int i[8] = { [0] 3 };
diff -urN gcc-3.3.3.orig/gcc/testsuite/g++.dg/warn/conv2.C gcc-3.3.3/gcc/testsuite/g++.dg/warn/conv2.C
--- gcc-3.3.3.orig/gcc/testsuite/g++.dg/warn/conv2.C	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/g++.dg/warn/conv2.C	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,3 @@
+// PR c++/13932
+
+int i = 1.; // { dg-warning "converting" }
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/compile/pr13889.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/compile/pr13889.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/compile/pr13889.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/compile/pr13889.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,7 @@
+/* PR target/13889 */
+struct { long long a; } *p;
+void initNetFlowFunct(void) {
+  unsigned int b = (unsigned int)-1;
+  p->a = b;
+}
+
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040218-1.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040218-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040218-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040218-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,37 @@
+/* PR target/14209.  Bug in cris.md, shrinking access size of
+   postincrement.
+   Origin: <hp@axis.com>.  */
+
+long int xb (long int *y) __attribute__ ((__noinline__));
+long int xw (long int *y) __attribute__ ((__noinline__));
+short int yb (short int *y) __attribute__ ((__noinline__));
+
+long int xb (long int *y)
+{
+  long int xx = *y & 255;
+  return xx + y[1];
+}
+
+long int xw (long int *y)
+{
+  long int xx = *y & 65535;
+  return xx + y[1];
+}
+
+short int yb (short int *y)
+{
+  short int xx = *y & 255;
+  return xx + y[1];
+}
+
+int main (void)
+{
+  long int y[] = {-1, 16000};
+  short int yw[] = {-1, 16000};
+
+  if (xb (y) != 16255
+      || xw (y) != 81535
+      || yb (yw) != 16255)
+    abort ();
+  exit (0);
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040302-1.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040302-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040302-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040302-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,24 @@
+int code[]={0,0,0,0,1};
+
+void foo(int x) {
+  volatile int b;
+  b = 0xffffffff;
+}
+
+void bar(int *pc) {
+  static const void *l[] = {&&lab0, &&end};
+
+  foo(0);
+  goto *l[*pc];
+ lab0:
+  foo(0);
+  pc++;
+  goto *l[*pc];
+ end:
+  return;
+}
+
+int main() {
+  bar(code);
+  return 0;
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040307-1.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040307-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040307-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040307-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,25 @@
+int main()
+{
+  int b = 0;
+
+  struct {
+    unsigned int bit0:1;
+    unsigned int bit1:1;
+    unsigned int bit2:1;
+    unsigned int bit3:1;
+    unsigned int bit4:1;
+    unsigned int bit5:1;
+    unsigned int bit6:1;
+    unsigned int bit7:1;
+  } sdata = {0x01};
+
+  while ( sdata.bit0-- > 0 ) {
+    b++ ;
+    if ( b > 100 ) break;
+  }
+
+  if (b != 1)
+    abort ();
+  return 0;
+}
+
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040309-1.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040309-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040309-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040309-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,16 @@
+/* PR middle-end/14470 */
+/* Origin: Lodewijk Voge <lvoge@cs.vu.nl> */
+
+extern void abort(void);
+
+int main()
+{
+  int t[1025] = { 1024 }, d;
+
+  d = 0;
+  d = t[d]++;
+  if (t[0] != 1025)
+    abort();
+  return 0;
+}
+
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040313-1.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040313-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040313-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040313-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,17 @@
+/* PR middle-end/14470 */
+/* Origin: Lodewijk Voge <lvoge@cs.vu.nl> */
+
+extern void abort(void);
+
+int main()
+{
+  int t[1025] = { 1024 }, d;
+
+  d = 0;
+  d = t[d]++;
+  if (t[0] != 1025)
+    abort();
+  if (d != 1024)
+    abort();
+  return 0;
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040331-1.c gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040331-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.c-torture/execute/20040331-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.c-torture/execute/20040331-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,12 @@
+/* PR c++/14755 */
+extern void abort (void);
+extern void exit (int);
+
+int
+main (void)
+{
+  struct { int count: 31; } s = { 0 };
+  while (s.count--)
+    abort ();
+  exit (0);
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040127-1.c gcc-3.3.3/gcc/testsuite/gcc.dg/20040127-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040127-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/20040127-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,24 @@
+/* PR target/10904 */
+/* Origin: <kminola@eng.umd.edu> */
+
+/* Verify that the register allocator correctly aligns
+   floating-point registers on SPARC64.  */
+
+/* { dg-do assemble } */
+/* { dg-options "-O2" } */
+
+extern int foo1();
+extern int foo2();
+
+void foo(int n, int b)
+{
+  int i, a;
+
+  foo1();
+
+  a = (long)(b * ((double) 0.1));
+
+  for (i=0; i < n; i++) {
+    foo2(a);
+  }
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040127-2.c gcc-3.3.3/gcc/testsuite/gcc.dg/20040127-2.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040127-2.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/20040127-2.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,32 @@
+/* PR target/13058 */
+/* Origin: Lloyd Parkes <lloyd@must-have-coffee.gen.nz> */
+/* Reduced testcase by  Falk Hueffner <falk@debian.org> */
+
+/* Verify that the register allocator correctly aligns
+   floating-point registers on SPARC64.  */
+
+/* { dg-do compile } */
+/* { dg-options "-O" } */
+
+typedef struct { int ThumbnailSize; } ImageInfo_t;
+
+double ConvertAnyFormat(void)
+{
+  return 0;
+}
+
+void ProcessExifDir(ImageInfo_t *ImageInfoP, int NumDirEntries)
+{
+  unsigned int ThumbnailSize;
+
+  for (; NumDirEntries;) {
+    Get16u();
+    switch (NumDirEntries) {
+      case 0x0201:
+      case 0x0202:
+        ThumbnailSize = ConvertAnyFormat();
+    }
+  }
+
+  ImageInfoP->ThumbnailSize = ThumbnailSize;
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040306-1.c gcc-3.3.3/gcc/testsuite/gcc.dg/20040306-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040306-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/20040306-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,22 @@
+/* This used to ICE due to a reload bug on s390*.  */
+
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+
+typedef struct test
+{
+  unsigned short pad;
+  unsigned char type[6];
+} t;
+
+extern void set (t *a, t *b, t *c, t *d, t *e, t *f, t *g, t *h, 
+		 t *i, t *j, t *k, t *l, t *m, t *n, t *o, t *p);
+extern void use (t a, t b, t c, t d, t e, t f, t g, t h,
+		 t i, t j, t k, t l, t m, t n, t o, t p);
+void test (void)
+{
+    t a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p;
+    set (&a, &b, &c, &d, &e, &f, &g, &h, &i, &j, &k, &l, &m, &n, &o, &p);
+    use (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p);
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040311-2.c gcc-3.3.3/gcc/testsuite/gcc.dg/20040311-2.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040311-2.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/20040311-2.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,36 @@
+/* PR target/14533 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -fpic" } */
+
+void bar (char *, int);
+
+extern char b[];
+extern int d, e;
+struct S
+{
+  struct S *m;
+  int n;
+} **g;
+
+void
+foo (int x, char *y)
+{
+  struct S *h;
+  int k = 1, l;
+
+again:
+  for (h = *g; h != (struct S *) g; h = h->m)
+    {
+      if (k == 0 && h->n & 0x100000);
+      l = y - b;
+      if (e)
+        bar (b, l);
+      if (d)
+        bar (b, l);
+    }
+  if (k)
+    {
+      k = 0;
+      goto again;
+    }
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040322-1.c gcc-3.3.3/gcc/testsuite/gcc.dg/20040322-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/20040322-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/20040322-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,4 @@
+/* PR c/14069 */
+/* { dg-do compile } */
+struct S { int a; char b[]; char *c; }; /* { dg-error "error" "flexible array member not" } */
+struct S s = { .b = "foo", .c = .b }; /* { dg-error "error" "parse error before" } */
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/const-1.c gcc-3.3.3/gcc/testsuite/gcc.dg/const-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/const-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/const-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,56 @@
+/* PR optimization/13472 */
+/* Origin: <p.van-hoof@qub.ac.uk> */
+
+/* Verify that the reload pass doesn't emit a store
+   to the .rodata section. */
+
+/* { dg-do run } */
+/* { dg-options "-O2 -pedantic -march=i686" { target i686-*-* } } */
+
+
+#define MAX2(a,b) (((a)>(b)) ? (a) : (b))
+
+const int q=0, p=0;
+
+typedef struct {
+	float a;
+	float b;
+} F;
+
+F **E, *D, C = { 2.f, 1.f };
+
+void G(float);
+void H(void);
+
+int main(void)
+{
+	D = &C;
+	E = &D;
+
+	H();
+        return 0;
+}
+
+void H(void)
+{
+	int i, l=1;
+	float b, o;
+
+	if( l )
+	{
+		b = 0.3f * MAX2(0.f,E[q][p].a - E[q][p].b);
+		o = E[q][p].a;
+		if( o > 1.e-36f )
+                        G(o);
+		E[q][p].a *= b;
+	}
+	else
+		b = 1.f;
+	for( i=q; i<2; ++i )
+		;
+}
+
+void G(float o)
+{
+}
+
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/gnu89-init-3.c gcc-3.3.3/gcc/testsuite/gcc.dg/gnu89-init-3.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/gnu89-init-3.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/gnu89-init-3.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,18 @@
+/* PR 11527 */
+/* { dg-do compile } */
+/* { dg-options "-std=gnu89" } */
+
+typedef struct smrdd_memory_blocks_s
+{
+  int blocks;
+  int block[];
+} smrdd_memory_blocks_t;
+
+const smrdd_memory_blocks_t smrdd_memory_blocks =
+{
+  3,
+  {
+    [5] = 5,
+    [1] = 2,
+  }
+};
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/inline-5.c gcc-3.3.3/gcc/testsuite/gcc.dg/inline-5.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/inline-5.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/inline-5.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,13 @@
+/* PR middle-end/13448 */
+
+/* { dg-options "-O3" } */
+
+void funct (const int n)
+{
+  n++; /* { dg-error "" } */
+}
+
+int main () {
+  funct (1);
+  return 0;
+}
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/noncompile/init-4.c gcc-3.3.3/gcc/testsuite/gcc.dg/noncompile/init-4.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/noncompile/init-4.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/noncompile/init-4.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,3 @@
+struct a { char *b; } c[D] /* { dg-error "undeclared" } */
+  =                        /* { dg-error "storage size" } */
+    { { "" } } ;  /* { dg-warning "braces around scalar initializer|near" } */
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/pr14289-1.c gcc-3.3.3/gcc/testsuite/gcc.dg/pr14289-1.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/pr14289-1.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/pr14289-1.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,12 @@
+/* PR middle-end/14289 */
+/* { dg-do compile { target i?86-*-* } } */
+/* { dg-options "-O0" } */
+
+register int a[2] asm("ebx");
+
+void Nase(void)
+{
+  int i=6;
+  a[i]=5;  /* { dg-error "address of global" } */
+}
+
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/pr14289-2.c gcc-3.3.3/gcc/testsuite/gcc.dg/pr14289-2.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/pr14289-2.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/pr14289-2.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,12 @@
+/* PR middle-end/14289 */
+/* { dg-do compile { target i?86-*-* } } */
+/* { dg-options "-O0" } */
+
+static register int a[2] asm("ebx");  /* { dg-error "multiple storage" } */
+
+void Nase(void)
+{
+  int i=6;
+  a[i]=5;  /* { dg-error "address of global" } */
+}
+
diff -urN gcc-3.3.3.orig/gcc/testsuite/gcc.dg/pr14289-3.c gcc-3.3.3/gcc/testsuite/gcc.dg/pr14289-3.c
--- gcc-3.3.3.orig/gcc/testsuite/gcc.dg/pr14289-3.c	1969-12-31 17:00:00.000000000 -0700
+++ gcc-3.3.3/gcc/testsuite/gcc.dg/pr14289-3.c	2004-04-20 02:29:00.000000000 -0600
@@ -0,0 +1,12 @@
+/* PR middle-end/14289 */
+/* { dg-do compile { target i?86-*-* } } */
+/* { dg-options "-O0" } */
+
+extern register int a[2] asm("ebx");  /* { dg-error "multiple storage" } */
+
+void Nase(void)
+{
+  int i=6;
+  a[i]=5;  /* { dg-error "address of global" } */
+}
+
diff -urN gcc-3.3.3.orig/gcc/toplev.c gcc-3.3.3/gcc/toplev.c
--- gcc-3.3.3.orig/gcc/toplev.c	2003-12-22 23:28:29.000000000 -0700
+++ gcc-3.3.3/gcc/toplev.c	2004-04-20 02:28:59.000000000 -0600
@@ -1,6 +1,6 @@
 /* Top level of GNU C compiler
    Copyright (C) 1987, 1988, 1989, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
-   1999, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.
+   1999, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.
 
 This file is part of GCC.
 
@@ -3057,6 +3057,13 @@
 	dump_flow_info (rtl_dump_file);
       /* CFG is no longer maintained up-to-date.  */
       tem = cse_main (insns, max_reg_num (), 1, rtl_dump_file);
+
+      /* Run a pass to eliminate duplicated assignments to condition
+	 code registers.  We have to run this after bypass_jumps,
+	 because it makes it harder for that pass to determine whether
+	 a jump can be bypassed safely.  */
+      cse_condition_code_reg ();
+
       purge_all_dead_edges (0);
       delete_trivially_dead_insns (insns, max_reg_num ());
 
diff -urN gcc-3.3.3.orig/gcc/tree-inline.c gcc-3.3.3/gcc/tree-inline.c
--- gcc-3.3.3.orig/gcc/tree-inline.c	2003-07-23 01:13:37.000000000 -0600
+++ gcc-3.3.3/gcc/tree-inline.c	2004-04-20 02:29:00.000000000 -0600
@@ -35,6 +35,7 @@
 #include "hashtab.h"
 #include "splay-tree.h"
 #include "langhooks.h"
+#include "diagnostic.h"
 
 /* This should be eventually be generalized to other languages, but
    this would require a shared function-as-trees infrastructure.  */
@@ -1442,6 +1443,13 @@
   inline_data id;
   tree prev_fn;
 
+
+  /* There is no point in performing inlining if errors have already
+     occurred -- and we might crash if we try to inline invalid
+     code.  */
+  if (errorcount || sorrycount)
+    return;
+        
   /* Clear out ID.  */
   memset (&id, 0, sizeof (id));
 
diff -urN gcc-3.3.3.orig/gcc/treelang/Make-lang.in gcc-3.3.3/gcc/treelang/Make-lang.in
--- gcc-3.3.3.orig/gcc/treelang/Make-lang.in	2003-07-08 07:28:41.000000000 -0600
+++ gcc-3.3.3/gcc/treelang/Make-lang.in	2004-04-20 02:29:00.000000000 -0600
@@ -132,15 +132,15 @@
 treelang.rest.encap: 
 
 .phony:treelang.info
-treelang.info: $(srcdir)/treelang/treelang.info
+treelang.info: $(srcdir)/treelang/treelang$(iv).info
 
-$(srcdir)/treelang/treelang.info: $(srcdir)/treelang/treelang.texi \
+$(srcdir)/treelang/treelang$(iv).info: $(srcdir)/treelang/treelang.texi \
 	 $(srcdir)/doc/include/gcc-common.texi \
 	 $(srcdir)/doc/include/gpl.texi \
 	 $(srcdir)/doc/include/fdl.texi \
 	 $(srcdir)/doc/include/funding.texi
-	cd $(srcdir) && $(MAKEINFO) $(MAKEINFOFLAGS) -Idoc/include \
-	-o treelang/treelang.info treelang/treelang.texi
+	cd $(srcdir) && $(MAKEINFO) $(MAKEINFOFLAGS) $(MAKEINFODEFS) -Idoc/include \
+	-o treelang/treelang$(iv).info treelang/treelang.texi
 
 treelang.dvi: $(srcdir)/treelang/treelang.texi \
 	 $(srcdir)/doc/include/gcc-common.texi \
@@ -177,19 +177,19 @@
 	done
 	$(STAMP) treelang.install.common.done
 
-treelang.install-info: $(srcdir)/treelang/treelang.info
-	if [ -f $(srcdir)/treelang/treelang.info ] ; then \
-	  rm -f $(DESTDIR)$(infodir)/treelang.info*; \
-	  for f in $(srcdir)/treelang/treelang.info*; do \
+treelang.install-info: $(srcdir)/treelang/treelang$(iv).info
+	if [ -f $(srcdir)/treelang/treelang$(iv).info ] ; then \
+	  rm -f $(DESTDIR)$(infodir)/treelang$(iv).info*; \
+	  for f in $(srcdir)/treelang/treelang$(iv).info*; do \
 	      realfile=`echo $$f | sed -e 's|.*/\([^/]*\)$$|\1|'`; \
 	      $(INSTALL_DATA) $$f $(DESTDIR)$(infodir)/$$realfile; \
 	  done; \
-	  chmod a-x $(DESTDIR)$(infodir)/treelang.info*; \
+	  chmod a-x $(DESTDIR)$(infodir)/treelang$(iv).info*; \
 	else true; fi
-	@if [ -f $(srcdir)/treelang/treelang.info ] ; then \
+	@if [ -f $(srcdir)/treelang/treelang$(iv).info ] ; then \
 	  if $(SHELL) -c 'install-info --version | sed 1q | fgrep -s -v -i debian' >/dev/null 2>&1; then \
-	    echo " install-info --info-dir=$(DESTDIR)$(infodir) $(DESTDIR)$(infodir)/treelang.info"; \
-	    install-info --info-dir=$(DESTDIR)$(infodir) $(DESTDIR)$(infodir)/treelang.info || : ; \
+	    echo " install-info --info-dir=$(DESTDIR)$(infodir) $(DESTDIR)$(infodir)/treelang$(iv).info"; \
+	    install-info --info-dir=$(DESTDIR)$(infodir) $(DESTDIR)$(infodir)/treelang$(iv).info || : ; \
 	  else : ; fi; \
 	else : ; fi
 
@@ -204,6 +204,7 @@
 	  echo -rm -rf $(DESTDIR)$(bindir)/$$name2$(exeext); \
 	  rm -rf $(DESTDIR)$(bindir)/$$name2$(exeext); \
 	done
+	-rm -f $(DESTDIR)$(infodir)/$(INFO_TREELANG_NAME).info*
 	-rm treelang.install.common.done
 
 #
diff -urN gcc-3.3.3.orig/gcc/unroll.c gcc-3.3.3/gcc/unroll.c
--- gcc-3.3.3.orig/gcc/unroll.c	2003-12-01 15:00:13.000000000 -0700
+++ gcc-3.3.3/gcc/unroll.c	2004-04-20 02:29:00.000000000 -0600
@@ -1119,6 +1119,11 @@
 	  unroll_type = UNROLL_MODULO;
 	  loop_preconditioned = 1;
 
+	  /* Preconditioning changes the loop's initial value.  We set
+	     it to an unknown value so that doloop_optimize won't get
+	     confused.  */
+	  loop_info->initial_value = 0;
+
 	  /* Clean up.  */
 	  free (labels);
 	}
diff -urN gcc-3.3.3.orig/gcc/varasm.c gcc-3.3.3/gcc/varasm.c
--- gcc-3.3.3.orig/gcc/varasm.c	2004-01-12 11:23:08.000000000 -0700
+++ gcc-3.3.3/gcc/varasm.c	2004-04-20 02:29:00.000000000 -0600
@@ -3188,24 +3188,6 @@
   return ptr;
 }
 
-/* Given a constant rtx X, return a MEM for the location in memory at which
-   this constant has been placed.  Return 0 if it not has been placed yet.  */
-
-rtx
-mem_for_const_double (x)
-     rtx x;
-{
-  enum machine_mode mode = GET_MODE (x);
-  struct constant_descriptor_rtx *desc;
-
-  for (desc = const_rtx_hash_table[const_hash_rtx (mode, x)]; desc;
-       desc = desc->next)
-    if (compare_constant_rtx (mode, x, desc))
-      return desc->rtl;
-
-  return 0;
-}
-
 /* Given a constant rtx X, make (or find) a memory constant for its value
    and return a MEM rtx to refer to it in memory.  */
 
diff -urN gcc-3.3.3.orig/include/ChangeLog gcc-3.3.3/include/ChangeLog
--- gcc-3.3.3.orig/include/ChangeLog	2004-02-14 13:19:38.000000000 -0700
+++ gcc-3.3.3/include/ChangeLog	2004-04-20 02:29:00.000000000 -0600
@@ -1,3 +1,22 @@
+2004-03-02  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	PR bootstrap/14348
+	Backport
+	2003-10-22  Joseph S. Myers  <jsm@polyomino.org.uk>
+	* obstack.h: Merge the following change from gnulib:
+	2003-10-21  Paul Eggert  <eggert@twinsun.com>
+	* obstack.h (obstack_1grow_fast): Properly parenthesize arg.
+	(obstack_ptr_grow_fast, obstack_int_grow_fast):
+	Don't use lvalue casts, as GCC plans to remove support for them
+	in GCC 3.5.  Reported by Joseph S. Myers.  This bug
+	was also present in the non-GCC version, indicating that this
+	code had always been buggy and had never been widely used.
+	(obstack_1grow, obstack_ptr_grow, obstack_int_grow,
+	obstack_blank):
+	Use the fast variant of each macro, rather than copying the
+	definiens of the fast variant; that way, we'll be more likely to
+	catch future bugs in the fast variants.
+
 2004-02-14  Release Manager
 
 	* GCC 3.3.3 Released.
